''''
Real Time Face Recogition
	==> Each face stored on dataset/ dir, should have a unique numeric integer ID as 1, 2, 3, etc                       
	==> LBPH computed model (trained faces) should be on trainer/ dir
Based on original code by Anirban Kar: https://github.com/thecodacus/Face-Recognition    

Developed by Marcelo Rovai - MJRoBot.org @ 21Feb18  

'''

import cv2
import numpy as np
import os 
import time

def recognition(rid) :
    trafile = '/home/pi/mirs_python/OpenCVFaceRecognition/FacialRecognition/trainer/trainer' + str(rid) + '.yml'
    recognizer = cv2.face.LBPHFaceRecognizer_create()
    recognizer.read(trafile)
    cascadePath = "/home/pi/mirs_python/OpenCVFaceRecognition/FacialRecognition/haarcascade_frontalface_default.xml"
    faceCascade = cv2.CascadeClassifier(cascadePath)

    font = cv2.FONT_HERSHEY_SIMPLEX

    #iniciate id counter
    #id = 0

    # names related to ids: example ==> Marcelo: id=1,  etc
    names = ['None', 'Iiduka', 'Nagasawa', 'Muraoka', 'Okamura', 'Kodani', 'Mano', 'Anma', 'Aikawa'] 

    # Initialize and start realtime video capture
    cam = cv2.VideoCapture(0)
    cam.set(3, 640) # set video widht
    cam.set(4, 480) # set video height

    # Define min window size to be recognized as a face
    minW = 0.1*cam.get(3)
    minH = 0.1*cam.get(4)

    #顔認証の開始時間
    start = time.time()

    while True:

        ret, img = cam.read()
        img = cv2.flip(img, -1) # Flip vertically

        gray = cv2.cvtColor(img,cv2.COLOR_BGR2GRAY)

        faces = faceCascade.detectMultiScale( 
            gray,
            scaleFactor = 1.2,
            minNeighbors = 5,
            minSize = (int(minW), int(minH)),
        )

        confidence = 0
        percent = 0

        for(x,y,w,h) in faces:

            cv2.rectangle(img, (x,y), (x+w,y+h), (0,255,0), 2)

            id, confidence = recognizer.predict(gray[y:y+h,x:x+w])

            # Check if confidence is less them 100 ==> "0" is perfect match 
            if (confidence < 100):
                id = names[rid]
                percent = 100 - confidence
                confidence = "  {0}%".format(round(100 - confidence))
            else:
                id = "unknown"
                confidence = "  {0}%".format(round(100 - confidence))
        
            cv2.putText(img, str(id), (x+5,y-5), font, 1, (255,255,255), 2)
            cv2.putText(img, str(confidence), (x+5,y+h-5), font, 1, (255,255,0), 1)  
            print(id)

        img = cv2.resize(img, (1020,765))  # サイズ変更
        cv2.imshow('camera',img) 
        cv2.moveWindow("camera", 1025,0) # Window表示位置指定

        end = time.time()
        protime = end - start

        print(percent)

        if (percent > 55) :
            match = 1
            break
        elif (protime > 8.0) :
            match = 0
            break

        k = cv2.waitKey(10) & 0xff # Press 'ESC' for exiting video
        if k == 27:
            break
    

    # Do a bit of cleanup
    print(match)
    print("\n [INFO] Exiting Program and cleanup stuff")
    cam.release()
    cv2.destroyAllWindows()

    return match

#recognition(8)
