import binascii
import nfc
import os
import errno
import contextlib
import signal

class TimeoutException(IOError):
    errno = errno.EINTR

@contextlib.contextmanager
def time_limit_with_sigalrm(timeout_secs):
    orig_sialrm_handler = signal.getsignal(signal.SIGALRM)
    def raise_excetion(signum, frame):
        raise TimeoutException

    signal.signal(signal.SIGALRM, raise_excetion)
    signal.alarm(timeout_secs)
    try:
        yield
    finally:
        signal.alarm(0)
        signal.signal(signal.SIGALRM, orig_sialrm_handler)

class MyCardReader(object):

	def __inti__(self) :
		self.room = 000

	def on_connect(self, tag):
		#タッチ時の処理
		print("【 Touched 】")

		#タグ情報を全て表示
		print(tag)

		#IDmのみ取得して表示
		self.idm = binascii.hexlify(tag._nfcid)
		print("IDm : " + str(self.idm))

		#特定のIDmだった場合のアクション
		if self.idm == b'04b4a085' :
			print("【飯塚蘭斗さんです!】")
			self.room = 101
		elif self.idm == b'043d9085' :
			print("【長澤稔幸さんです!】")
			self.room = 102
		elif self.idm == b'e4948c85' :
			print("【村岡真聡さんです!】")
			self.room = 103
		elif self.idm == b'b496a385' :
			print("【小谷耀さんです!】")
			self.room = 105
		elif self.idm == b'a4339585' :
			print("【眞野未央さんです!】")
			self.room = 106
		elif self.idm == b'e44b9485' :
			print("【安間丈紘さんです!】")
			self.room = 107
		elif self.idm == b'e4dd8e85' :
			print("【相川将斗さんです!】")
			self.room = 108
		else :
			self.room = 1000

		return True

	#def timeout(self) :	#3秒経過
		#self.room = 0
		#return self.room

	def read_id(self):
		clf = nfc.ContactlessFrontend('usb')
		with time_limit_with_sigalrm(3):
			try:
				self.room = 0
				clf.connect(rdwr={'on-connect': self.on_connect})
			except TimeoutException :
				self.room = 0
			finally:
				clf.close()
				return self.room

if __name__ == '__main__':
	cr = MyCardReader()
	while True:
		#最初に表示
		print("Please Touch")

		#タッチ待ち
		cr.read_id()

		print('続行しますか？')
		key = input()
		if key == 'q':
			break

def id():
	cr = MyCardReader()
	#最初に表示
	print("Please Touch")

	#タッチ待ち
	room = cr.read_id()

	return room

